/*

    File: cow.shader

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
//cow shader

varying vec3 normal;
varying vec3 mvVertex;

#ifdef VERTEX_SHADER
void main() {
	normal = gl_NormalMatrix * gl_Normal;
	mvVertex = gl_Vertex.xyz;
	gl_Position = ftransform();
}
#endif

#ifdef FRAGMENT_SHADER

uniform sampler3D noiseTex;
void main() {
	
	//do some lighting
	const vec3 light = vec3(0,0,1);
	float dp = dot(normalize(normal),light);
	float lum = dp;	//pow(dp,1);
	gl_FragColor = vec4(lum);

	//add some splotches
	vec4 noise = texture3D(noiseTex, mvVertex * .125);
	float n = (noise.x + noise.y + noise.z + noise.w) * .25;
	if (n < .5) gl_FragColor *= .1;
	gl_FragColor *= pow(texture3D(noiseTex, mvVertex * 2.).w + .5, 10.);
}
#endif
